
#ifndef _H_MCUTIL_COLLEC_GEN_VEC
#define _H_MCUTIL_COLLEC_GEN_VEC

#include "mcutil/mcutil.h"
#include <stddef.h>


typedef struct mcu_gen_vec_s {
    void** inner;
    size_t count;
    size_t capacity;
} mcu_gen_vec_t;


MCU_API void mcu_gen_vec_init(mcu_gen_vec_t* gv);
MCU_API void  mcu_gen_vec_insert_front(mcu_gen_vec_t* gv, void* data);
MCU_API void  mcu_gen_vec_insert_back(mcu_gen_vec_t* gv, void* data);
MCU_API void* mcu_gen_vec_remove_back(mcu_gen_vec_t *gv);
MCU_API void* mcu_gen_vec_remove_front(mcu_gen_vec_t *gv);

#endif
